#include <stdio.h>
#include "plugin.h"

/* zadefinovani vlastni promenne */
float hodnota;	/* sirka sterea(1.0, 2.0, 2.5) */
int stav; 		/* 1-mono 2-stereo(2) 3-stereo(2.5)*/

/* definice funkci */
static void init(void);
static void cleanup(void);
static void about(void);
static void configure(void);
static int mod_samples(gpointer *d, gint length, AFormat afmt, gint srate, gint nch);

/* nutne pro inicializaci v XMMS */
EffectPlugin ep = {
	NULL,						/* prirazuje XMMS */
	NULL,						/* prirazuje XMMS */
	"Stereo Plugin (ChipCD)",   /* popis v dialogu Nastaveni */
	init,						/* fukce volana pri startu */
	cleanup,					/* funkce volana pri ukoncovani */
	about,						/* funkce volana pri stisku tlac. O Pluginu */
	configure,					/* funkce volana pri stisku tlac. Konfigurovat */
	mod_samples,				/* funkce provadejici upravu vystupniho zvuku */
	NULL						
};

EffectPlugin *get_eplugin_info(void){
	return &ep;
}

/* kod mnou vytvorenych funkci */
static void about(void){
	/* vypise info o pluginu po stisknuti */
	/* tlacitka "O Pluginu" v XMMS        */
	printf("Stereo plugin (ChipCD): Pokusny plugin rubriky Linux z ChipCD :-)\n");
}

static void init(void){
	/* pri nacteni pluginu do XMMS se provede tato funkce */
	hodnota = 0.0;
	stav = 0;
	printf("Stereo plugin (ChipCD): XMMS me inicializovalo hodnotami 0.0(hodnota) a 0(stav).\n");
}

static void cleanup(void){
	/* Pri vypnuti (korektnim) se provede tato funkce */
	printf("Stereo plugin (ChipCD): XMMS konci, ja koncim taky.\n");
}

static void configure(void){
	/* Pri stisknuti "Konfigurovat" se provede tato funkce */
	/* Tato konkretni fce: hloupa rotace stavu             */
	stav++;
	if(stav==1){   /* mono */
		hodnota=1.0;
		printf("Stereo plugin (ChipCD): Nastavuji MONO.\n");
	}
	if(stav==2){  /* stereo 2.0 */
		hodnota=2.0; 
		printf("Stereo plugin (ChipCD): Nastavuji STEREO(2).\n");
	}
	if(stav==3){ /* stereo 2.5 */
		hodnota=2.5;
		printf("Stereo plugin (ChipCD): Nastavuji STEREO(2.5).\n");
		stav=0;         /* stav zpatky na zacatku */
	}
	
}

/* funkce slouzici k uprave reprodukovane hudby */
static int mod_samples(gpointer *d, gint length, AFormat afmt, gint srate, gint nch)
{
	gint i;
	double prumer, ldif, rdif, tmp, nasobek;
	gint16  *data = (gint16 *)*d;

	/* urceni formatu cisel - technicka vec - doporucuji */
	if (!(afmt == FMT_S16_NE ||
	      (afmt == FMT_S16_LE && G_BYTE_ORDER == G_LITTLE_ENDIAN) ||
	      (afmt == FMT_S16_BE && G_BYTE_ORDER == G_BIG_ENDIAN)) ||
	    nch != 2)
		return length;

	nasobek = hodnota;
	
	for (i = 0; i < length / 2; i += 2)
	{
		prumer = (data[i] + data[i + 1]) / 2;
		ldif = data[i] - prumer;
		rdif = data[i + 1] - prumer;

		tmp = prumer + (ldif * nasobek);
		if (tmp < -32768)
			tmp = -32768;
		if (tmp > 32767)
			tmp = 32767;
		data[i] = tmp;

		tmp = prumer + (rdif * nasobek);
		if (tmp < -32768)
			tmp = -32768;
		if (tmp > 32767)
			tmp = 32767;
		data[i + 1] = tmp;
	}
	return length;
}
